Description: autotoolization/pytoolization: harden: build directory
 Attempt to harden the building machinery by (1) implementing a more
 autotools way to perform external build, by (2) distinguishing the
 build directory wrt to the PARI/GP support, and (3) by adding the
 possibly to pass arguments to `configure' through a dedicated
 environment variable, named `PYSETUP_CONFIGURE_FLAGS'. Meant to be
 submitted to the upstream maintainer team.
Origin: vendor, Debian
Forwarded: https://github.com/sagemath/cysignals/pull/38
Author: Jerome Benoit <calculus@rezozer.net>
Last-Update: 2018-11-01

--- a/setup.py
+++ b/setup.py
@@ -29,9 +29,6 @@
 
 opj = os.path.join
 
-
-cythonize_dir = "build"
-
 macros = [
     # Disable .c line numbers in exception tracebacks
     ("CYTHON_CLINE_IN_TRACEBACK", 0),
@@ -39,7 +36,7 @@
 
 depends = glob(opj("src", "cysignals", "*.h"))
 
-ac_configure_flags = ""
+ac_configure_flags = os.environ.get("PYSETUP_CONFIGURE_FLAGS","--without-pari")
 if "--without-pari" in sys.argv:
 	ac_configure_flags = "--without-pari"
 	sys.argv.remove("--without-pari")
@@ -47,6 +44,13 @@
 	ac_configure_flags = "--with-pari"
 	sys.argv.remove("--with-pari")
 
+cythonize_subdir = "XXXX"
+if "--without-pari" in ac_configure_flags:
+	cythonize_subdir = "bare"
+elif "--with-pari" in ac_configure_flags:
+	cythonize_subdir = "pari"
+cythonize_dir = opj("build", cythonize_subdir)
+
 if sys.platform == 'cygwin':
     # On Cygwin FD_SETSIZE defaults to a rather low 64; we set it higher
     # for use with PSelecter
@@ -58,7 +62,9 @@
 # false positives in the longjmp() check.
 undef_macros = ["_FORTIFY_SOURCE"]
 
-kwds = dict(include_dirs=[opj("src"),
+kwds = dict(include_dirs=[opj("build", cythonize_subdir, "src"),
+                          opj("build", cythonize_subdir, "src", "cysignals"),
+                          opj("src"),
                           opj("src", "cysignals")],
             depends=depends,
             define_macros=macros,
@@ -147,7 +153,11 @@
                     is_newer_than(filename + '.in', filename))
 
         if any(needs_reconfigure(f) for f in self.configure_outputs):
-            subprocess.check_call(['sh', 'configure'] + self.configure_flags)
+            subprocess.check_call(
+                "make configure && mkdir -p " + cythonize_dir +
+                " && " +
+                "{ cd " + cythonize_dir + " ; ../../configure " + ac_configure_flags + " ; }" ,
+              shell=True)
 
 
 class build_ext(_build_ext):
